"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var helper_plugin_utils_1 = require("@babel/helper-plugin-utils");
var t = __importStar(require("@babel/types"));
var ast_1 = require("./utils/ast");
exports.default = helper_plugin_utils_1.declare(function (api) {
    api.assertVersion(7);
    return {
        name: '@compiled/babel-plugin-strip-runtime',
        pre: function () {
            this.styleRules = [];
        },
        visitor: {
            Program: {
                exit: function () {
                    if (this.opts.onFoundStyleRules) {
                        this.opts.onFoundStyleRules(this.styleRules);
                    }
                },
            },
            ImportSpecifier: function (path) {
                if (t.isIdentifier(path.node.imported) && ['CC', 'CS'].includes(path.node.imported.name)) {
                    path.remove();
                }
            },
            JSXElement: function (path, pass) {
                if (!t.isJSXIdentifier(path.node.openingElement.name)) {
                    return;
                }
                var componentName = path.node.openingElement.name.name;
                if (componentName !== 'CC') {
                    return;
                }
                var _a = path.get('children'), compiledStyles = _a[1], nodeToReplace = _a[3];
                // Before we replace this node with its children we need to go through and remove all the
                // style declarations from the CS call.
                ast_1.removeStyleDeclarations(compiledStyles.node, path, pass);
                if (t.isJSXExpressionContainer(nodeToReplace.node)) {
                    var container = nodeToReplace;
                    path.replaceWith(container.node.expression);
                }
                else {
                    path.replaceWith(nodeToReplace);
                }
                // All done! Let's replace this node with the user land child.
                path.node.leadingComments = null;
                return;
            },
            CallExpression: function (path, pass) {
                var callee = path.node.callee;
                if (ast_1.isCreateElement(callee)) {
                    // We've found something that looks like React.createElement(...)
                    // Now we want to check if it's from the Compiled Runtime and if it is - replace with its children.
                    var component = path.node.arguments[0];
                    if (!ast_1.isCCComponent(component)) {
                        return;
                    }
                    var _a = path.get('arguments'), compiledStyles = _a[2], nodeToReplace = _a[3];
                    // Before we replace this node with its children we need to go through and remove all the
                    // style declarations from the CS call.
                    ast_1.removeStyleDeclarations(compiledStyles.node, path, pass);
                    // All done! Let's replace this node with the user land child.
                    path.replaceWith(nodeToReplace);
                    path.node.leadingComments = null;
                    return;
                }
                if (ast_1.isAutomaticRuntime(path.node, 'jsxs')) {
                    // We've found something that looks like _jsxs(...)
                    // Now we want to check if it's from the Compiled Runtime and if it is - replace with its children.
                    var component = path.node.arguments[0];
                    if (!ast_1.isCCComponent(component)) {
                        return;
                    }
                    var _b = path.get('arguments'), props = _b[1];
                    if (!t.isObjectExpression(props.node)) {
                        return;
                    }
                    var children = props.node.properties.find(function (prop) {
                        return (t.isObjectProperty(prop) && t.isIdentifier(prop.key) && prop.key.name === 'children');
                    });
                    if (!children || !t.isArrayExpression(children.value)) {
                        return;
                    }
                    var _c = children.value.elements, compiledStyles = _c[0], nodeToReplace = _c[1];
                    if (!t.isExpression(nodeToReplace) || !t.isExpression(compiledStyles)) {
                        throw new Error('Nodes should be expressions.');
                    }
                    // Before we replace this node with its children we need to go through and remove all the
                    // style declarations from the CS call.
                    ast_1.removeStyleDeclarations(compiledStyles, path, pass);
                    // All done! Let's replace this node with the user land child.
                    path.replaceWith(nodeToReplace);
                    path.node.leadingComments = null;
                    return;
                }
            },
        },
    };
});
//# sourceMappingURL=index.js.map