import * as t from '@babel/types';
import type { NodePath } from '@babel/core';
import type { PluginPass } from '../types';
/**
 * Returns `true` if `node` looks like `React.createElement()`.
 *
 * @param node
 * @returns
 */
export declare const isCreateElement: (node: t.Node) => node is t.CallExpression;
/**
 * Returns `true` if `node` looks like a `jsx()` like call expression.
 *
 * @param node
 * @param func
 * @returns
 */
export declare const isAutomaticRuntime: (node: t.Node, func: 'jsx' | 'jsxs') => node is t.CallExpression;
/**
 * Returns the children of a `jsx()` call expression.
 *
 * @param node
 * @returns
 */
export declare const getJsxRuntimeChildren: (node: t.CallExpression) => Array<t.Expression>;
/**
 * Returns `true` if `node` looks like `CC` identifier.
 *
 * @param node
 * @returns
 */
export declare const isCCComponent: (node: t.Node) => boolean;
/**
 * Will remove found style declarations tied to the passed in `node`,
 * and callback with any found.
 *
 * @param node
 * @param parentPath
 * @param pass
 */
export declare const removeStyleDeclarations: (node: t.Node, parentPath: NodePath<any>, pass: PluginPass) => void;
